// Movement and Collision

x += hsp;
y += vsp;

if (hsp != 0) || (vsp != 0) moveTmr -= walksp;

if (moveTmr <= 0) 
{
	moveTmr = moveMax;
	
	if (z >= elev-20) && (zsp >= 0)
	{
		// Turn
		if (place_meeting(x,y,oTurn)) turnBob(instance_place(x,y,oTurn).image_index);
		
		// Hole
		var target = noone;
		if (place_meeting(x,y,oHole))
		{
			if (state != PSTATE.HOLE)
			{
				target = instance_place(x,y,oHole)
				getWinText(irandom_range(1,6));
				state = PSTATE.HOLE;
				audio_play_sound(zLame,0,false);
				anchorX = target.x;
				anchorY = target.y;
			}
		}
		
		// Spring
		if (place_meeting(x,y,oSpring))
		{
			target = instance_place(x,y,oSpring);
			audio_play_sound(zSpring,0,false);
			target.springTmr = 16;
			zsp = -4;
			z = 0;
		}	
		
		// Turnspring
		if (place_meeting(x,y,oSpringTurn))
		{
			target = instance_place(x,y,oSpringTurn);
			audio_play_sound(zSpring,0,false);
			target.springTmr = 16;
			target.prevImage = target.image_index;
			turnBob(target.image_index);
			zsp = -4;
			z = 0;
		}	
		
		// Sign
		if (place_meeting(x,y,oSign))
		{
			target = instance_nearest(x,y-16,oSign);
			audio_play_sound(zBreak,0,false);
			vsp = 0;
			if (target.image_index == 0) hsp = -walksp;
			else hsp = walksp;
			zsp = -2;
			grv = 1/32;
		}
		
		// Rocket
		if (place_meeting(x,y,oRocket))
		{
			state = PSTATE.STOP;
			visible = false;
			oRocket.blastoff = true;
		}
	}
}

if (place_meeting(x,y,pWall)) 
{
	audio_play_sound(zZap,0,false);
	state = PSTATE.STOP;
	oGame.tint = true;
	getLoseText(irandom_range(1,6));
	hsp *= -1;
	vsp *= -1;
}

// Lava

if (place_meeting(x,y,oLava))
{
	elev = 20;
	if (z == elev) 
	{
		audio_play_sound(zLame,0,false);
		tmr = 5;
		oGame.tint = true;
		getLoseText(irandom_range(1,6));
		state = PSTATE.BURN;
	}
}
else elev = 0;

if (x < 0) || (x > room_width) || (y < 0) || (y > room_height)
{
	hsp *= -1;
	vsp *= -1;
	oGame.tint = true;
	getLoseText(irandom_range(1,6));
	audio_play_sound(zLame,0,false);
	tmr = 5;
	state = PSTATE.BURN;
}

// Z Val

zsp += grv;
if (z+zsp>=elev)
{
	zsp = 0;
	z = elev;
}
z += zsp;

